<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Decl. Operators</TITLE>
<link href="builder_35.html" rel=Next>
<link href="builder_33.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_33.html">previous</A>, <A HREF="builder_35.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC65" HREF="builder_toc.html#TOC65">Operators</A></H2>
<P>
<A NAME="IDX519"></A>

</P>
<P>
These operators can be used to construct expressions by explicitly
calling the operator functions See section <A HREF="builder_33.html#SEC64">Constructing Expressions Using Explicit Function Calls</A>. 

</P>
<P>
<A NAME="IDX520"></A>
<A NAME="IDX521"></A>

<PRE>
<A NAME="IDX522"></A>enum unary_op { uop_minus,                     // -a
<A NAME="IDX523"></A><A NAME="IDX524"></A>                 uop_not,                       // !a
<A NAME="IDX525"></A><A NAME="IDX526"></A>                 uop_lnot,                      // ~a
<A NAME="IDX527"></A><A NAME="IDX528"></A>                 uop_abs };                     // abs(a) or |a|
<A NAME="IDX529"></A>
<A NAME="IDX530"></A>enum &#60;binary_op { bop_mul,                       // a * b
<A NAME="IDX531"></A><A NAME="IDX532"></A>                 bop_div,                       // a / b
<A NAME="IDX533"></A><A NAME="IDX534"></A>                 bop_mod,                       // a % b
<A NAME="IDX535"></A><A NAME="IDX536"></A>                 bop_add,                       // a + b
<A NAME="IDX537"></A><A NAME="IDX538"></A>                 bop_sub,                       // a - b
<A NAME="IDX539"></A><A NAME="IDX540"></A>                 bop_lshift,                    // a &#60;&#60; b
<A NAME="IDX541"></A><A NAME="IDX542"></A>                 bop_rshift,                    // a &#62;&#62; b
<A NAME="IDX543"></A><A NAME="IDX544"></A>                 bop_less,                      // (a &#60; b)
<A NAME="IDX545"></A><A NAME="IDX546"></A>                 bop_gt,                        // (a &#62; b)
<A NAME="IDX547"></A><A NAME="IDX548"></A>                 bop_leq,                       // (a &#60;= b)
<A NAME="IDX549"></A><A NAME="IDX550"></A>                 bop_geq,                       // (a &#62;= b)
<A NAME="IDX551"></A><A NAME="IDX552"></A>                 bop_eq,                        // (a == b)
<A NAME="IDX553"></A><A NAME="IDX554"></A>                 bop_neq,                       // (a != b)
<A NAME="IDX555"></A><A NAME="IDX556"></A>                 bop_and,                       // a &#38; b
<A NAME="IDX557"></A><A NAME="IDX558"></A>                 bop_xor,                       // a ^ b
<A NAME="IDX559"></A><A NAME="IDX560"></A>                 bop_or,                        // a | b
<A NAME="IDX561"></A><A NAME="IDX562"></A>                 bop_land,                      // a &#38;&#38; b
<A NAME="IDX563"></A><A NAME="IDX564"></A>                 bop_lor,                       // a || b
<A NAME="IDX565"></A><A NAME="IDX566"></A>                 bop_divfloor,             // (int)floor((double)a/(double)b)
<A NAME="IDX567"></A><A NAME="IDX568"></A>                 bop_divceil,              // (int)ceil((double)a/(double)b)
<A NAME="IDX569"></A><A NAME="IDX570"></A>                 bop_min,                       // min(a, b)
<A NAME="IDX571"></A>                 bop_max };                     // max(a, b)
<A NAME="IDX572"></A>
<A NAME="IDX573"></A>enum assign_op { aop_eq,                        // a = b;
<A NAME="IDX574"></A><A NAME="IDX575"></A>                 aop_mod,                       // a = a % b;
<A NAME="IDX576"></A><A NAME="IDX577"></A>                 aop_add,                       // a = a + b;
<A NAME="IDX578"></A><A NAME="IDX579"></A>                 aop_sub,                       // a = a - b;
<A NAME="IDX580"></A><A NAME="IDX581"></A>                 aop_mul,                       // a = a * b;
<A NAME="IDX582"></A><A NAME="IDX583"></A>                 aop_div,                       // a = a / b;
<A NAME="IDX584"></A><A NAME="IDX585"></A>                 aop_rshift,                    // a = a &#62;&#62; b;
<A NAME="IDX586"></A><A NAME="IDX587"></A>                 aop_lshift,                    // a = a &#60;&#60; b;
<A NAME="IDX588"></A><A NAME="IDX589"></A>                 aop_and,                       // a = a &#38; b;
<A NAME="IDX590"></A><A NAME="IDX591"></A>                 aop_xor,                       // a = a ^ b;
<A NAME="IDX592"></A><A NAME="IDX593"></A>                 aop_or };                      // a = a | b;
<A NAME="IDX594"></A><A NAME="IDX595"></A></PRE>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_33.html">previous</A>, <A HREF="builder_35.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
